c – 为什么不调用意外功能?

我希望以下代码调用我的意外处理程序,但我的终止处理程序被调用:

#include <except>
#include <iostream>

void my_terminate() {
    std::cerr << "my terminate handler";
    std::exit(0);
}

void my_unexpected() {
    std::cerr << "my unexpected handler";
    std::exit(EXIT_FAILURE);
}

#pragma argsused
int main(int argc, char* argv[])
{
    std::set_terminate(my_terminate);
    std::set_unexpected(my_unexpected);
    try {
        throw std::exception();
    } catch (const std::logic_error&) {
    }
    return 0;
}

C++ Builder 6 Developer’s Guide明确鼓励通过set_unexpected()安装自定义意外处理程序.我做错了什么,或者这只是C -Builder 6中的一个错误?

最佳答案
当抛出意外异常时,将调用由std :: set_unexpected(对于std::unexpected)调用设置的处理程序;不是在未处理异常的情况下.当违反动态异常规范时,将调用意外的处理程序.

举例来说;

void my_terminate() {
    std::cerr << "my terminate handler";
    std::exit(0);
}

void my_unexpected() {
    std::cerr << "my unexpected handler";
    std::exit(EXIT_FAILURE);
}

void function() throw() // no exception in this example, but it could be another spec
{
    throw std::exception();
}

int main(int argc, char* argv[])
{
    std::set_terminate(my_terminate);
    std::set_unexpected(my_unexpected);
    try {
        function();
    } catch (const std::logic_error&) {
    }
    return 0;
}

输出是

my unexpected handler

由std :: set_terminate设置的处理程序由std::terminate调用(由于参考中列出的多种原因).这里感兴趣的是抛出异常但未捕获异常时的默认行为是调用std :: terminate.

转载注明原文:c – 为什么不调用意外功能? - 代码日志